#include "StdAfx.h"
#include "DlgHelper.h"
#include <tchar.h>

//ȡԻĳؼĿͻ

void GetItemRectInClient(HWND hDlg, int itemId, LPRECT lpRect)
{
	POINT pt = {0, 0};

	//õͻʼĻ
	ClientToScreen(hDlg, &pt);
	
	//õؼĻ
	GetWindowRect(GetDlgItem(hDlg, itemId), lpRect);
	
	lpRect->left -= pt.x;
	lpRect->top -= pt.y;
	lpRect->right -= pt.x;
	lpRect->bottom -= pt.y;
}


// ʼԻλ,  PS SDK ṩһԺ
// 
// ע⣺ԻStyleӦΪPopupɶԸھ
//       ΪOverlappedûиڣĻС
//

void CenterDialog(HWND hDlg)
{
	int  nWidth, nHeight, nTitleBits;
    RECT rcDialog, rcParent;
    int  xOrigin, yOrigin, xScreen, yScreen;

    HWND hParent = GetParent(hDlg);

    if(hParent == NULL)
        hParent = GetDesktopWindow();

    GetClientRect(hParent, &rcParent);
    ClientToScreen(hParent, (LPPOINT)&rcParent.left);  // point(left,  top)
    ClientToScreen(hParent, (LPPOINT)&rcParent.right); // point(right, bottom)

    // Center on Title: title bar has system menu, minimize,  maximize bitmaps
    // Width of title bar bitmaps - assumes 3 of them and dialog has a sysmenu
    nTitleBits = GetSystemMetrics(SM_CXSIZE);

    // If dialog has no sys menu compensate for odd# bitmaps by sub 1 bitwidth
    if  ( ! (GetWindowLong(hDlg, GWL_STYLE) & WS_SYSMENU))
        nTitleBits -= nTitleBits / 3;

    GetWindowRect(hDlg, &rcDialog);
    nWidth  = rcDialog.right  - rcDialog.left;
    nHeight = rcDialog.bottom - rcDialog.top;

	//ˮƽ
    xOrigin = max(rcParent.right - rcParent.left - nWidth, 0)/2  + rcParent.left - nTitleBits;
    
	xScreen = GetSystemMetrics(SM_CXSCREEN);

	//ֹܷԻҲ೬ĻΧ
    if  (xOrigin + nWidth > xScreen)
        xOrigin = max (0, xScreen - nWidth);

	//ֱеƫ
	yOrigin = max(rcParent.bottom - rcParent.top - nHeight, 0)/3 + rcParent.top;
    
	yScreen = GetSystemMetrics(SM_CYSCREEN);
    
	//ֹܷԻײĻΧ
	if  (yOrigin + nHeight > yScreen)
        yOrigin = max(0 , yScreen - nHeight);

    SetWindowPos(hDlg, NULL, xOrigin, yOrigin, nWidth, nHeight, SWP_NOZORDER);
}

//ڶԻϻַ
void DrawStringOnDlg(HDC hdc, LPCTSTR text, int degree, int x, int y)
{
	LOGFONT lf;
	memset(&lf, 0, sizeof(lf));
	lf.lfHeight = 14;
	lf.lfEscapement = degree * 10;
	lf.lfOrientation = degree * 10;
	lf.lfWeight = FW_NORMAL;
	lf.lfCharSet = DEFAULT_CHARSET;
	//lf.lfQuality = ANTIALIASED_QUALITY;
	_tcscpy(lf.lfFaceName,_T("Arial"));

	HFONT hFont = CreateFontIndirect(&lf);
	if(hFont != NULL)
	{
		HGDIOBJ hOldFont = SelectObject(hdc, hFont);
		SetTextColor(hdc, RGB(0, 64, 255));
		SetBkMode(hdc, TRANSPARENT);
		TextOut(hdc, x, y, text, _tcslen(text));
		SelectObject(hdc, hOldFont);
		DeleteObject(hFont);
	}
}

//ΪԻͼ
void SetIconForDlg(HWND hDlg, LPCTSTR lpszIcon)
{
	//ICON
	HINSTANCE hInst = (HINSTANCE)GetWindowLong(hDlg, GWL_HINSTANCE);
	HICON hIconBig = (HICON)LoadImage(hInst, lpszIcon, IMAGE_ICON,
		32, 32, LR_DEFAULTCOLOR);
	HICON hIconSmall = (HICON)LoadImage(hInst, lpszIcon, IMAGE_ICON,
		16, 16, LR_DEFAULTCOLOR);

	SendMessage(hDlg, WM_SETICON, ICON_BIG, (LPARAM)hIconBig);
	SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIconSmall);
}

//ȡͳλͬһĿ¼ļľ·
//buffer: [in,out]·
//shortFileName: [in]NULLʱӦóĿ¼
void GetAppFolderFileName(LPTSTR buffer, LPCTSTR shortFileName)
{
	//ӦóĿ¼(βбַ)
	static TCHAR szAppFolder[MAX_PATH];

	//ǷѾȡӦóĿ¼
	if(szAppFolder[0] == 0)
	{
		TCHAR *pChar = NULL;
		//ȡִļļ·
		GetModuleFileName(NULL, szAppFolder, MAX_PATH);

		//ķб
		pChar = _tcsrchr(szAppFolder, _T('\\'));
		if(pChar != NULL)
		{
			*pChar = 0; //ضַ
		}
	}
	
	if(shortFileName == NULL)
		_tcscpy(buffer, szAppFolder);
	else
		_stprintf(buffer, _T("%s\\%s"), szAppFolder, shortFileName);
}

//GetLastErrorصĴ룬תΪϢַ
void GetErrorMsg(DWORD errcode, LPTSTR buffer)
{
	LPVOID lpMsgBuf;

	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,	//dwFlags
		NULL,		//lpSource
		errcode,	//dwMessageId 
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),	//dwLanguageId 
		(LPTSTR)&lpMsgBuf,	//lpBuffer 
		0,					//nSize
		NULL				//Arguments
		);

	_tcscpy(buffer, (LPTSTR)lpMsgBuf);

	LocalFree(lpMsgBuf);
}